package org.jeecg.modules.spare.controller;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.util.oConvertUtils;
import org.jeecg.modules.spare.entity.BuSpareEntryItem;
import org.jeecg.modules.spare.entity.BuSparePart;
import org.jeecg.modules.spare.service.IBuSpareEntryItemService;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.extern.slf4j.Slf4j;

import org.jeecg.modules.spare.service.IBuSparePartService;
import org.jeecgframework.poi.excel.ExcelImportUtil;
import org.jeecgframework.poi.excel.def.NormalExcelConstants;
import org.jeecgframework.poi.excel.entity.ExportParams;
import org.jeecgframework.poi.excel.entity.ImportParams;
import org.jeecgframework.poi.excel.view.JeecgEntityExcelView;
import org.jeecg.common.system.base.controller.JeecgController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;
import com.alibaba.fastjson.JSON;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.jeecg.common.aspect.annotation.AutoLog;

 /**
 * @Description: 备件入库明细
 * @Author: jeecg-boot
 * @Date:   2020-12-22
 * @Version: V1.0
 */
@Api(tags="备件入库明细")
@RestController
@RequestMapping("/spare/buSpareEntryItem")
@Slf4j
public class BuSpareEntryItemController extends JeecgController<BuSpareEntryItem, IBuSpareEntryItemService> {
	@Autowired
	private IBuSpareEntryItemService buSpareEntryItemService;
	@Autowired
	private IBuSparePartService buSparePartService;

	/**
	 * 分页列表查询
	 *
	 * @param buSpareEntryItem
	 * @param pageNo
	 * @param pageSize
	 * @param req
	 * @return
	 */
	@AutoLog(value = "备件入库明细-分页列表查询")
	@ApiOperation(value="备件入库明细-分页列表查询", notes="备件入库明细-分页列表查询")
	@GetMapping(value = "/list")
	public Result<?> queryPageList(BuSpareEntryItem buSpareEntryItem,
								   @RequestParam(name="pageNo", defaultValue="1") Integer pageNo,
								   @RequestParam(name="pageSize", defaultValue="10") Integer pageSize,
								   HttpServletRequest req) {
		QueryWrapper<BuSpareEntryItem> queryWrapper = QueryGenerator.initQueryWrapper(buSpareEntryItem, req.getParameterMap());
		Page<BuSpareEntryItem> page = new Page<BuSpareEntryItem>(pageNo, pageSize);
		IPage<BuSpareEntryItem> pageList = buSpareEntryItemService.page(page, queryWrapper);
		return Result.OK(pageList);
	}

	/**
	 *   添加
	 *
	 * @param buSpareEntryItem
	 * @return
	 */
	@AutoLog(value = "备件入库明细-添加")
	@ApiOperation(value="备件入库明细-添加", notes="备件入库明细-添加")
	@PostMapping(value = "/add")
	public Result<?> add(@RequestBody BuSpareEntryItem buSpareEntryItem) {
		BuSparePart buSparePart = buSparePartService.getSpareById(buSpareEntryItem.getSpareId());
		int number1 = buSparePart.getNum();
		int number2 = buSpareEntryItem.getNumber();
		int num = number1 + number2;
		buSparePart.setNum(num);
		buSparePartService.updateById(buSparePart);
		buSpareEntryItemService.updateById(buSpareEntryItem);
		buSpareEntryItemService.save(buSpareEntryItem);
		return Result.OK("添加成功！");
	}

	/**
	 *  编辑
	 *
	 * @param buSpareEntryItem
	 * @return
	 */
	@AutoLog(value = "备件入库明细-编辑")
	@ApiOperation(value="备件入库明细-编辑", notes="备件入库明细-编辑")
	@PutMapping(value = "/edit")
	public Result<?> edit(@RequestBody BuSpareEntryItem buSpareEntryItem) {
		BuSparePart buSparePart = buSparePartService.getSpareById(buSpareEntryItem.getSpareId());
		int number1 = buSparePart.getNum();
		int number2 = buSpareEntryItem.getNumber();
		int num = number1 + number2;
		buSparePart.setNum(num);
		buSparePartService.updateById(buSparePart);
		buSpareEntryItemService.updateById(buSpareEntryItem);
		return Result.OK("编辑成功!");
	}

	/**
	 *   通过id删除
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "备件入库明细-通过id删除")
	@ApiOperation(value="备件入库明细-通过id删除", notes="备件入库明细-通过id删除")
	@DeleteMapping(value = "/delete")
	public Result<?> delete(@RequestParam(name="id",required=true) String id) {
		buSpareEntryItemService.removeById(id);
		return Result.OK("删除成功!");
	}

	/**
	 *  批量删除
	 *
	 * @param ids
	 * @return
	 */
	@AutoLog(value = "备件入库明细-批量删除")
	@ApiOperation(value="备件入库明细-批量删除", notes="备件入库明细-批量删除")
	@DeleteMapping(value = "/deleteBatch")
	public Result<?> deleteBatch(@RequestParam(name="ids",required=true) String ids) {
		this.buSpareEntryItemService.removeByIds(Arrays.asList(ids.split(",")));
		return Result.OK("批量删除成功!");
	}

	/**
	 * 通过id查询
	 *
	 * @param id
	 * @return
	 */
	@AutoLog(value = "备件入库明细-通过id查询")
	@ApiOperation(value="备件入库明细-通过id查询", notes="备件入库明细-通过id查询")
	@GetMapping(value = "/queryById")
	public Result<?> queryById(@RequestParam(name="id",required=true) String id) {
		BuSpareEntryItem buSpareEntryItem = buSpareEntryItemService.getById(id);
		if(buSpareEntryItem==null) {
			return Result.error("未找到对应数据");
		}
		return Result.OK(buSpareEntryItem);
	}

    /**
    * 导出excel
    *
    * @param request
    * @param buSpareEntryItem
    */
    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, BuSpareEntryItem buSpareEntryItem) {
        return super.exportXls(request, buSpareEntryItem, BuSpareEntryItem.class, "备件入库明细");
    }

    /**
      * 通过excel导入数据
    *
    * @param request
    * @param response
    * @return
    */
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, BuSpareEntryItem.class);
    }

}
